<script lang="ts">
  import { getLocalizer } from '../module/utils.js'

  import { Tabs, Tab, TabList, TabPanel } from 'svelte-tabs/src/index.js'
  import BaseStats from './actor-sheet/tabs/BaseStats.svelte'
  import CombatStats from './actor-sheet/tabs/CombatStats.svelte'
  import TalentList from './actor-sheet/tabs/TalentList.svelte'
  import Karma from './actor-sheet/tabs/Karma.svelte'
  import ActorSheetHeader from './actor-sheet/ActorSheetHeader.svelte'
  import DerivedAttributes from './actor-sheet/DerivedAttributes.svelte'
  import Resources from './actor-sheet/Resources.svelte'

  import type { CharacterDataAccessor } from '../module/model/character.js'
  import SpellList from './actor-sheet/tabs/SpellList.svelte'
  import SourceList from './actor-sheet/tabs/SourceList.svelte'
  import FormulaList from './actor-sheet/tabs/FormulaList.svelte'
  import Description from './actor-sheet/tabs/Description.svelte'
  import { getContext } from 'svelte'
  import Inventory from './actor-sheet/tabs/Inventory.svelte'
  import { Writable } from 'svelte/store'
  import WoundThresholds from './actor-sheet/WoundThresholds.svelte'
  import Wounds from './actor-sheet/Wounds.svelte'
  import { getSystemSetting } from '../module/settings.js'

  const localize = getLocalizer()

  let doc = getContext<Writable<CharacterDataAccessor>>('doc')

  $: isMyranorSetting = getSystemSetting('myranor')
</script>

<ActorSheetHeader />

<div class="container">
  <div class="derived column">
    <DerivedAttributes />
  </div>
  <div class="tabs column">
    <Tabs>
      <TabList>
        <Tab>{localize('character')}</Tab>
        <Tab>{localize('talents')}</Tab>
        <Tab>{localize('spells')}</Tab>
        {#if isMyranorSetting}
          <Tab>{localize('sources')}</Tab>
          <Tab>{localize('formulas')}</Tab>
        {/if}
        <Tab>{localize('karma')}</Tab>
        <Tab>{localize('combat')}</Tab>
        <Tab>{localize('inventory')}</Tab>
        <Tab>{localize('description')}</Tab>
      </TabList>

      <TabPanel>
        <BaseStats />
      </TabPanel>

      <TabPanel>
        <TalentList />
      </TabPanel>

      <TabPanel>
        <SpellList />
      </TabPanel>

      {#if isMyranorSetting}
        <TabPanel>
          <SourceList />
        </TabPanel>
        <TabPanel>
          <FormulaList />
        </TabPanel>
      {/if}

      <TabPanel>
        <Karma />
      </TabPanel>

      <TabPanel>
        <CombatStats />
      </TabPanel>

      <TabPanel>
        <Inventory />
      </TabPanel>

      <TabPanel>
        <Description />
      </TabPanel>
    </Tabs>
  </div>
  <div class="res column">
    <Resources bind:resources={$doc.system.base.resources} />
    <WoundThresholds />
    <Wounds />
  </div>
</div>

<style>
  :global(.svelte-tabs) {
    height: 100%;
    width: 100%;
  }
  :global(.svelte-tabs .svelte-tabs__tab-list) {
    text-align: center;
  }
  :global(.svelte-tabs div.svelte-tabs__tab-panel):not(:empty) {
    height: 100%;
  }

  .column {
    float: left;
  }
  .container:after {
    content: '';
    display: table;
    clear: both;
  }

  .derived {
    width: 15%;
  }

  .tabs {
    width: 70%;
  }

  .res {
    width: 15%;
    padding-left: 25px;
  }
</style>
